package com.agentfactory.agentspeak.interpreter.control;

import java.util.List;

import com.agentfactory.agentspeak.interpreter.mentalstate.PlanRule;
import com.agentfactory.logic.update.reasoner.IQueryEngine;
import com.agentfactory.logic.update.reasoner.QueryResult;

public class BasicOptionSelector implements IOptionSelector {
	private IQueryEngine queryEngine;
	
	public BasicOptionSelector(IQueryEngine queryEngine) {
		this.queryEngine = queryEngine;
	}
	
	@Override
	public PlanRule select(List<PlanRule> options) {
		for (PlanRule option: options) {
			// Check that the context of the plan rule is satisfied and
			// create a commitment for only the set of bindings that
			// were identified.
			QueryResult result = queryEngine.query(option.getContext());
			if (result.found) {
				if (result.bindings.isEmpty()) {
					return option;
				} else {
					return option.apply(result.bindings.get(0));
				}
			}
		}
		return null;
	}

}
