/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.logic.agent;

import com.agentfactory.logic.agent.Ontology;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

/**
 *
 * @author remcollier
 */
public class OntologyManager {
    private Map ontologies;
    
    public OntologyManager() {
        ontologies = new HashMap();
    }
    
    public void addOntology(Ontology ontology) {
        ontologies.put(ontology.getIdentifier(), ontology);
    }
    
    public Ontology getOntology(String identifier) {
        return (Ontology) ontologies.get(identifier);
    }
    
    public Iterator getOntologyIdentifiers() {
        return ontologies.keySet().iterator();
    }
    
    public String getOntologyFor(String functor) {
        Ontology ontology = null;

        boolean found = false;
        Iterator it = ontologies.values().iterator();
        while (!found && it.hasNext()) {
            ontology = (Ontology) it.next();
            found = ontology.getPredicate(functor) != null;
        }
        if (!found) return null;
        
        return ontology.getIdentifier();
    }
    
    public List<Ontology> getOntologies() {
        List<Ontology> list = new LinkedList<Ontology>();
        Iterator it = ontologies.values().iterator();
        while (it.hasNext()) {
            list.add((Ontology) it.next());
        }
        
        return list;
    }
}
