package com.agentfactory.logic.update.lang;

import java.util.HashSet;
import java.util.Set;

import com.agentfactory.logic.update.reasoner.Bindings;

public class EQUALS implements ITerm {
	private ITerm[] terms;
	
	public EQUALS(ITerm[] terms) {
		this.terms = terms;
	}
	
	@Override
	public ITerm apply(Bindings set) {
		ITerm[] t = new ITerm[2];
		t[0] = terms[0].apply(set);
		t[1] = terms[1].apply(set);
		if (t[0].isConstant() && t[1].isConstant()) {
			int d1 = Integer.parseInt(((Function) t[0]).functor());
			int d2 = Integer.parseInt(((Function) t[1]).functor());
			int answer = d1 + d2;
			return new Function(""+answer);
		}
		return this;
	}

	@Override
	public boolean containsVariable(Variable variable) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isCompatibleFunction(ITerm term) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isConstant() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isDistinctFunction(ITerm term) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isNotFunctional(ITerm term) {
		// TODO Auto-generated method stub
		return false;
	}

	public ITerm term(int i) {
		return terms[i];
	}

	@Override
	public boolean hasTerms() {
		// Ignore this property for arithmetic
		// TODO (Rem Collier): Refactor this to be better...
		return false;
	}

	@Override
	public Set<Variable> getVariables() {
		Set<Variable> set = new HashSet<Variable>();
		set.addAll(terms[0].getVariables());
		set.addAll(terms[1].getVariables());
		return set;
	}

	public boolean matches(ITerm term) {
		if (!EQUALS.class.isInstance(term)) {
			return false;
		}
		
		EQUALS op = (EQUALS) term;
		return terms[0].matches(op.terms[0]) && terms[1].matches(op.terms[1]);
	}
}
