package com.agentfactory.teleoreactive.compiler;

import java.util.LinkedList;
import java.util.List;

import com.agentfactory.logic.update.interpreter.CoreUtilities;
import com.agentfactory.logic.update.lang.AND;
import com.agentfactory.logic.update.lang.IFormula;
import com.agentfactory.teleoreactive.interpreter.Utilities;

public class SentenceBuilderVisitor implements TeleoReactiveParserVisitor {
	@Override
	public Object visit(SimpleNode node, Object data) {
		if (node.toString().equals("Context")) {
			List<IFormula> list = new LinkedList<IFormula>();
			for (int i=0; i<node.jjtGetNumChildren(); i++) {
				if (node.jjtGetChild(i).toString().equals("Formula")) {
					SimpleNode litNode = (SimpleNode) node.jjtGetChild(i).jjtGetChild(0);
					if (litNode.toString().equals("Literal")) {
						String fos = "";
						if (litNode.jjtGetValue() != null) {
							fos += "~";
						}
						fos += new PredicateConstructorVisitor().visit((SimpleNode) litNode.jjtGetChild(0), null);
						list.add(Utilities.factory.createFormula(fos));
					} else if (litNode.toString().equals("Comparison")) {
						String fos = "" +new PredicateConstructorVisitor().visit((SimpleNode) litNode.jjtGetChild(0), null);
						fos += litNode.jjtGetValue();
						fos += new PredicateConstructorVisitor().visit((SimpleNode) litNode.jjtGetChild(1), null);
//						System.out.println("String: "+fos);
//						System.out.println("Comparison: "+litNode.jjtGetChild(1).toString());
						list.add(CoreUtilities.factory.createFormula(fos));
					} else {
						System.out.println("Not Implemented: " + litNode.toString());
					}
				} else {
					System.out.println("Not Implemented: " + node.jjtGetChild(i).toString());
				}
			}
			return new AND(list);
		} else 
		return null;
	}
}
